package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   󷿤Ǥ

   constantǤбޤ
*/
public class Constant {

    /** 롼 */
    private Group group;

    /** ̾ */
    private QualifiedName name;

    /**  */
    private String value;

    /** descǤ */
    private Description desc;

    /**
       󷿤ޤ

       @param g 롼
       @param elem constant
    */
    public Constant(final Group g, final Element elem) {
	group = g;
	name = g.expandNS(elem, "name");
	value = elem.getAttribute("value");
	if (elem.getAttributeNode("value") != null && value.equals("")) {
	    String m = "empty value";
	    throw new NodeException(elem.getAttributeNode("value"), m);
	}

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(g, c.getDirectChildrenByTagName("desc"));
    }

    /**
       ̾ޤ

       @return ̾
    */
    public QualifiedName getName() {
	return name;
    }

    /**
       󷿤ΥФɽʸޤ

       ͤꤵƤʤ硢֤̾ޤǤ
        "̾ = " ֤ޤ

       @return 󷿤Υ
    */
    public String getCode() {
	String n = name.getQualified();
	if (value.equals("")) {
	    return n;
	}
	return n + " = " + value;
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	wr.println(""
+ "<tr>\n"
+ "  <td><a href=\"#" + name + "\"><b>" + name.getSimple() + "</b></a>"
+ "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	wr.println(""
+ "<dl><a name=\"" + name + "\"></a>" + name.getSimple() + "<dd>\n"
+ desc.getText() + "</dd></dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	String texName = Tex.safe(name.getSimple());
	String ns = group.getPackageName() + "." + group.getName();
	String texLabel = Tex.safeTarget(ns + "." + name);

	wr.println("");
	wr.println("\\Sconstant{" + texName + "}");
	wr.println("\\Slabel{:" + texLabel + ":}");
	wr.println("\\nopagebreak");
	wr.println("\\begin{Sindentation}{\\Sindentlength}{0pt}");

	// Description
	wr.println("");
	wr.println(desc.getTexText());

	wr.println("\\end{Sindentation}");
    }
}
